local addonName, ChatAssistant = ...

ChatAssistant.defaults = {

  version = GetAddOnMetadata(addonName, "Version"),
  enabled = false,
  autoInvite = false,
  autoWhisper = false,
  linkColor = "cffff00ff",
  whisperText = "Hi!",
  channel = {},
  autoPost = false,
  autoPostDelay = 60,
  autoPostText = "ChatAssistant message for post in line1|Text in line2",
  autoPostTicker = {},
  ignoreList = {},
  ignoreListMsg = {},
  channelListN = "[None]",
  currMsg = "",
  operator = {true,false,true,false,true},
  critOn = {false,true,true,true,true,},
  critIn = {true,true,true,true,false,},
  mmicon = true,
  autoPostTimes = 0,
  singleWhisper = true,

  criteria = {
    [1] = {
      "Head ",
      "Heart ",
      "Голов ",
      "Сердц ",
    },
    [2] = {
      "UBRS ",
      "УБРС ",
    },
    [3] = {
      "DPS ",
      "дд ",
    },
    [4] = {
      "NEWORDCRITERIA1",
      "NEWORDCRITERIA2",
    },
    [5] = {
      "EXCLUDECRITERIA1",
      "OR",
      "EXLUDECRITERIA2",
    },

  }

}
ChatAssistantSettings = ChatAssistantSettings or ChatAssistant.defaults

function ChatAssistant.toggle()
  if ChatAssistantSettings.enabled then
    print(addonName .. " |cffff3333Disabled|r")
    ChatAssistantSettings.enabled = false
  else
    print(addonName .. " |cff33ff33Enabled|r")
    ChatAssistantSettings.enabled = true
  end
end

function ChatAssistant.postInChannels()
  for channel,listening in pairs(ChatAssistantSettings.channel) do
    if listening then
      for id, line in ipairs(ChatAssistantSettings.autoPostText:Split("|")) do
      SendChatMessage(line, "CHANNEL", nil, channel)
      end
    end
  end
end

function ChatAssistant.handleChatEvent(...) 

  if not ChatAssistantSettings.enabled  then return value  end
  local msg, fromPlayerRealm, _, eventChannel = ...  
  local msgB = string.upper(msg)

  local fromPlayer = fromPlayerRealm:Split("-")[1]  
  local currentPlayer, realm = UnitName("player")
  if fromPlayer == currentPlayer then return end     

  for channelNumber, listening in pairs(ChatAssistantSettings.channel) do
    if eventChannel:find(channelNumber) and listening then
      ChatAssistant.parseMSG(msgB, fromPlayer, channelNumber, msg)
    end
  end

end


function ChatAssistant.parseMSG(msg, playerName, channelNumber, Omsg)
  local postfixText = "[Sent by ChatAssistant]"
  local matches = {}
  local minCriteria = 0
  local isDisplayed = false
  local currMessage = ChatAssistantSettings.currMsg
  local totalSearchCrit = table.Length(ChatAssistantSettings.criteria)
  local searchCritCount = 0
  local playerLink = "|"..ChatAssistantSettings.linkColor.."|Hplayer:"..playerName.."|h["..playerName.."]|h|r";

  for _,searchCrit in pairs(ChatAssistantSettings.criteria) do
   searchCritCount = searchCritCount + 1 
   if ChatAssistantSettings.critOn[searchCritCount] 
   then
      if searchCritCount > 1 then
           if ChatAssistantSettings.operator[searchCritCount] then 
              if minCriteria > 0 then minCriteria = minCriteria - 1 end  
              else 
              minCriteria = 0 
              matches = {}
           end
      end
      if (table.getn(searchCrit) > 0) then minCriteria = minCriteria + 1 end   

      if totalSearchCrit > searchCritCount then   
      if ChatAssistantSettings.operator[searchCritCount+1] then
       for i in ipairs(ChatAssistantSettings.operator) do
        if (i > searchCritCount) then
          if ChatAssistantSettings.critOn[i] then
             if ChatAssistantSettings.operator[i] then minCriteria = minCriteria + 1 
             break
             end
          end 
        end
       end 
       end 
      end

      local W = 0
      local F = 0
      for _,crit in pairs(searchCrit) do
      W = W + 1

         if msg:FindI(crit) then 
	                    if ChatAssistantSettings.critIn[searchCritCount] then table.insert(matches, crit)                                                           
                              else                minCriteria = minCriteria + 1                             
                            end 
                            break
         else               if not ChatAssistantSettings.critIn[searchCritCount] then F = F + 1
                            end 
         end
      end
      if (not ChatAssistantSettings.critIn[searchCritCount] and W == F) then minCriteria = minCriteria - 1 end

  if (table.getn(matches) >= minCriteria and minCriteria > 0)  then
    local id, chanName = GetChannelName(channelNumber);

    local ignoreCB = function(_, _, reason)
      print("ChatAssistant Ignoring: " .. playerName)
      table.insert(ChatAssistantSettings.ignoreList, playerName)
      table.insert(ChatAssistantSettings.ignoreListMsg, msg)
      ChatAssistantSettings.currMsg = ""
    end

    local whisperCB = function()
      ChatAssistantSettings.autoPostTimes = ChatAssistantSettings.autoPostTimes + 1
      SendChatMessage(ChatAssistantSettings.whisperText.." "..postfixText, "WHISPER", nil, playerName)
      if ChatAssistantSettings.singleWhisper then ignoreCB() end
    end
    local whisperCBmanual = function()
      ChatAssistantSettings.autoPostTimes = ChatAssistantSettings.autoPostTimes + 1
      SendChatMessage(ChatAssistantSettings.whisperText.." "..postfixText, "WHISPER", nil, playerName)
      ChatAssistantSettings.currMsg = ""
      if ChatAssistantSettings.singleWhisper then ignoreCB() end
    end

    local inviteCB = function(_, _, reason)
      if reason == "clicked" then
        print("Inviting", playerName)
        InviteUnit(playerName)
      end
    end
    local inviteCBmanual = function(_, _, reason)
      if reason == "clicked" then
        print("Inviting", playerName)
        InviteUnit(playerName)
        ChatAssistantSettings.currMsg = ""
      end
    end

    local skipCB = function(_, _, reason)
       ChatAssistantSettings.currMsg = ""
    end

    for i, ignoredPlayer in ipairs(ChatAssistantSettings.ignoreList) do
      if playerName == ignoredPlayer   then
        if ChatAssistantSettings.ignoreListMsg[i] == msg then print("ChatAssistant Ignored " .. ignoredPlayer)
          else print("ChatAssistant Ignored " .. ignoredPlayer .. " with message: " .. Omsg)
        end       
        return 
      end
    end
    if currMessage == msg then 
     print("ChatAssistant ignoring the same massage from", playerName..": ".. msg)
     return
    end
  if not isDisplayed then
    PlaySound(SOUNDKIT.READY_CHECK) 
  
    ChatAssistantSettings.currMsg = msg   

    if ChatAssistantSettings.autoWhisper then
      whisperCB()
    end
    
    if ChatAssistantSettings.autoInvite then
      inviteCB(nil,nil,"clicked")
      ChatAssistant.shoPopUp(playerLink.." "..msg.."\n\n Whisper: "..ChatAssistantSettings.whisperText, 20, "Whisper", "Cancel", "Ignore", whisperCBmanual, skipCB, ignoreCB, true)
      isDisplayed = true
    end
    if not isDisplayed then       
      ChatAssistant.shoPopUp(playerLink.." "..msg.."\n\n Whisper: "..ChatAssistantSettings.whisperText, 20, "Whisper", "Invite", "Ignore", whisperCBmanual, inviteCBmanual, ignoreCB)
    end
   end 

   break
   end 
  end


  end
  
end

